#include <stdlib.h>
#include <math.h>

/* Uniform deviates */

/* You may want to use another random generator.
   Put your favorite one here. */

double ran1(long *idum)
{
  if(*idum<0) {srand48(- *idum); *idum = 1;}
  else if(*idum==0) {srand48(5437); *idum = 1;}

  return drand48();
}

#ifndef M_PI
#define M_PI            3.14159265358979323846
#endif

/* Gaussian N(0,1) deviate, you may want to change 
   this routine as well */

double boxmuller(long *idum, double (*func)())
{
  static int seesaw=0;
  static double x1,x2;

  double r1,r2;

  if(seesaw==0)
    {
      r1 = sqrt(-2.0*log((*func)(idum)));
      r2 = (*func)(idum);
      
      x1 = r1*sin(2.0*M_PI*r2);
      x2 = r1*cos(2.0*M_PI*r2);

      seesaw = 1;

      return x1;
    }
  else
    {
      seesaw = 0;

      return x2;
    }
}
  


double fastnorm(long *idum, double mean, double sd, double (*func)())
{
  return mean + sd*boxmuller(idum, func);
}
